# disable compression stripping and other checks in install phase 
#%%global __os_install_post %%{nil}

%define 	own	asterisk
%define 	grp	asterisk
%define 	sown	root
%define 	sgrp	root
%define 	rawname	framework

Name:		freepbx
Version:	17.0.19.24
Release:	1%{?dist}
Summary:	FreePBX Framework

License:	See the attached README file
Source0:	https://mirror.freepbx.org/modules/packages/%{rawname}/%{rawname}-%{version}.tgz
Source2:	amportal.conf 
Source3:	freepbx.conf 
Source4:	freepbx_chown.conf 
Source5:	freepbx.service
Source100:	README.freepbx.9
Source101:	APACHE_MOD_PHP.freepbx.9
Source102:	APACHE_MOD_PHP.freepbx.8
Source103:	APACHE_PHP_FPM.freepbx.9
Source104:	APACHE_PHP_FPM.freepbx.8
Source105:	LIGHTTPD.freepbx
Source106:	INSTALL.freepbx
Source107:	CDR.freepbx
Source108:	NOTES.freepbx
Source120:	freePBXAsterisk.te

# TODO prendere i .htconfig e metterli in file di sistema
Patch0:		freepbx-framework-17.0.19.21-installcommand.patch
Patch1:		freepbx-framework-16.0.21.10-installcommand_odbc.patch 
Patch2:		freepbx-framework-16.0.21.10-installcommand_no_amportal_conf.patch
Patch3:		freepbx-framework-16.0.10.43-installcommand_no_modules_install.patch
Patch4:		freepbx-framework-16.0.10.43-installcommand_skip_install.patch
Patch10:	freepbx-framework-16.0.10.50-installphp_cleanups.patch
Patch20:	freepbx-framework-17.0.19.21-Console-force_nochown.patch
Patch21:	freepbx-framework-17.0.19.21-modulefunctions.patch
Patch22:	freepbx-framework-16.0.40.2-fwconsole_nochown.patch
# Ce ne sono altri di chown, e chgrp, e installazioni varie. intanto iniziamo
Patch23:	freepbx-framework-16.0.10.43-gqp-nochowns.patch
# Questa non la applichiamo, xche e' utile che le config in /etc/asterisk siano di asterisk, anche quando generate da fwconsole reload: altri il reload da web page non le puo' sovrascrivere
Patch24:	freepbx-framework-16.0.10.43-writeconfig-nochown.patch
Patch25:	freepbx-framework-17.0.19.21-fwconsole_nocron.patch
Patch26:	freepbx-framework-16.0.10.50-fwconsole_nosystem.patch
Patch27:	freepbx-framework-16.0.10.50-fwconsole_novalidate.patch
Patch28:	freepbx-framework-16.0.10.50-fwconsole_noupdatemanager.patch
Patch29:	freepbx-framework-16.0.10.50-reloadNoSymlinkNoCopy.patch
# Ci sara' poi da decidere se sia veramente lecito, che fwconsole stop stoppi *
Patch30:	freepbx-framework-17.0.19.21-fwconsole_start_stop_asterisk.patch
# Non usata ora
Patch31:	freepbx-framework-16.0.19-restart_no_asterisk.patch
Patch40:	freepbx-framework-16.0.10.43-install_path.patch
# Stavolta sono io che aggiungo un chown. Se loggo qualcosa da cli, il file qualora inesistente apparterra' a root, quindi apache non potra' scriverlo.
Patch41:	freepbx-framework-16.0.10.50-logger_chown.patch
# Analogo in /usr/share/freepbx/admin/assets/less/cache
Patch42:	freepbx-framework-16.0.10.43-less.dochown.patch
# Analogo in BMO/Views
Patch43:	freepbx-framework-17.0.19.21-BMO-View-dochown.patch
Patch44:	freepbx-framework-16.0.40.7-BMO-Cron-dochown.patch
# Qui cerco di eliminare i riferimenti ai systemUpdates, MA TODO: prima o poi, eliminerei del tutto Builtin/SystemUpdates.php, Builtin/UpdateManager.php, Console/System.class.php, Console/Updatemanager.class.php
# Per cercare velocemente:
# grep 'System Updates\|canDoSystemUpdates\|auto_system_updates\|fetchAutomaticUpdate\|getsystemupdates\|System Upgrades' -rsl| grep -v i18n
Patch60:	freepbx-framework-16.0.10.43-noSystemUpdates.patch
# Elimina la config degli updates dalla schermata OOBE (Out Of the Box qualcosa), che e' po il setup iniziale. Non lo chiediamo nemmeno, tanto gli update sono banditi
Patch61:	freepbx-framework-17.0.19.21-noUpdatesInOOBE.patch
# Toglie dalla interfaccia web alcuni elementi per l'update dei pacchetti
Patch62:	freepbx-framework-16.0.10.43-ExternalPackageManagement.patch
# In 16.0.21.18 compare hooks/switch-asterisk-version . Freepbx non deve cambiare *, quindi tolgo questo hook sotto, ed elimino qui le funzioni che sembrava chiamare
Patch63:	freepbx-framework-16.0.21.18-updateAsterisk.patch
# Don't do signature check
Patch80:	freepbx-framework-17.0.19.21-nosigcheck.patch
Patch81:	freepbx-framework-17.0.19.21-noGPG.patch
# Patch di funzionalita' generiche
Patch200:	freepbx-framework-16.0.19-FOPWEBROOT.patch
# Dont try to load chan_local.so: it was removed several years ago, about in v13. It was logging lines like this:
# ERROR[2409459] loader.c: Error loading module 'chan_local.so': /usr/lib64/asterisk/modules/chan_local.so: cannot open shared object file: No such file or directory
Patch201:	freepbx-framework-16.0.28-no_chan_local.patch

BuildRequires:  systemd-rpm-macros
%{?systemd_requires}
Requires:	php(httpd)
Requires:	php-mysqli
#Requires:	php-pear-DB	# not found in C8 epel, likely not needed any more
Requires:	asterisk
#Requires:	freepbx-certman		# I currently don't build this, let's see in the future.
#Requires:	httpd-itk	# TODO decide whether to impose use of apache or not (and/or a specific apache module). Maybe write packages for apache, lighttpd etc

Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd

Provides:	freepbx = %{version}-%{release}

BuildArch:	noarch

%description
The goal of FreePBX project is to bring together best-of-breed applications to produce a
standardized implementation of Asterisk complete with a Web-based administrative interface.
This module provides the framework code that is not otherwise housed in a module

%prep
%setup -q -n %{rawname}
%patch0 -p1
%patch1 -p0
#%patch2 -p0
#%patch3 -p0
%patch4 -p0
%patch10 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
#%patch24 -p1
%patch25 -p1
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p1
%patch40 -p0
%patch41 -p0
%patch42 -p0
%patch43 -p1
%patch44 -p0
#%patch60 -p0
%patch61 -p1
%patch62 -p0
%patch63 -p1
%patch80 -p1
%patch81 -p1
%patch200 -p1
%patch201 -p1

# Controlliamo la eventuale presenza di particolarita' da gestire
for ddd in sbin sounds moh ; do
        [ -e amp_conf/$ddd ] && echo presente amp_conf/$ddd, va gestito && exit 1
done

# Non mi va di lanciare gpg a destra e a manca, solo per venire a sapere che ho modificato i moduli
%{__rm} module.sig

# Delete backup files
find . -name '*.orig' -exec rm '{}' ';'
find . -depth -name '.git*' -exec rm -rf '{}' ';'

# fix dir perms
find . -type d -exec chmod 755 '{}' ';'
find . -type f -exec chmod 644 '{}' ';'
#find . -type f -regex '.*\.\(php\|html\)$' -exec chmod 644 '{}' ';'

# Questa non mi piace pertanto la tolgo, e pazienza se avremo qualche disagio da gestire. Mi ricorda chi faceva chmod -R 777 / "per evitare problemi".
%{__rm} amp_conf/htdocs/admin/libraries/Console/Chown.class.php
%{__rm} amp_conf/htdocs/admin/libraries/Console/System.class.php
%{__rm} amp_conf/htdocs/admin/libraries/Console/Validate.class.php
%{__rm} amp_conf/htdocs/admin/libraries/Console/Updatemanager.class.php
%{__rm} amp_conf/htdocs/admin/libraries/BMO/GPG.class.php

# Non sto a richiedere + perl da quando uso mock: sed lo ho gia', prob e' nella dotazione standard
#perl -pi -e 's|^astmoddir\b.*|astmoddir=/usr/lib64/asterisk/modules|; s|^astvarlibdir\b.*|astvarlibdir=/usr/share/asterisk\nastdbdir=/var/spool/asterisk\nastkeydir=/var/lib/asterisk\nastdatadir=/usr/share/asterisk|; s|^astagidir\b.*|astagidir=/usr/share/asterisk/agi-bin|; s|^astrundir\b.*|astrundir=/run/asterisk|;' installlib/files/asterisk.conf
sed -i 's|^astmoddir\>.*|astmoddir=/usr/lib64/asterisk/modules|; s|^astvarlibdir\>.*|astvarlibdir=/usr/share/asterisk\nastdbdir=/var/spool/asterisk\nastkeydir=/var/lib/asterisk\nastdatadir=/usr/share/asterisk|; s|^astagidir\>.*|astagidir=/usr/share/asterisk/agi-bin|; s|^astrundir\>.*|astrundir=/run/asterisk|' installlib/files/asterisk.conf

#perl -ni -e 'next if 1 .. m|^cat\b|; next if m|^EOF$|; print' hooks/logrotate
sed -i '1,/^cat /d;/^EOF$/,$d' hooks/logrotate
# Semplice metodo x accorgermi, fallendo qualora vengano introdotti nuovi hooks da gestire
%{__mkdir} etclogrotate.d
%{__mv} hooks/logrotate etclogrotate.d/freepbx-fwJOB
# Notare che ci sono riferimenti almeno ad upgrade-all-module in amp_conf/htdocs/admin/libraries/Api/Gql/Modules.php : va trimmato opportunamente anche quello
%{__rm} hooks/README.md  hooks/upgrade-all-module  hooks/yum-check-updates  hooks/yum-run-update  hooks/yum-update-system hooks/switch-asterisk-version hooks/list-system-updates hooks/update-language
# Semplice metodo x accorgermi, fallendo qualora vengano introdotti nuovi hooks da gestire
rmdir hooks

# it's the mod' developer sake, if he is using a deprecated function. I regret it, but I see no reason to pollute the logs in normal working environment.
#perl -pi -e '/Depreciated Function .* detected in .* on line / and s/LOG_WARNING/LOG_DEBUG/' amp_conf/htdocs/admin/libraries/modulefunctions.legacy.php amp_conf/htdocs/admin/libraries/BMO/Modules.class.php 
sed -i '/Depreciated Function .* detected in .* on line /s/LOG_WARNING/LOG_DEBUG/' amp_conf/htdocs/admin/libraries/modulefunctions.legacy.php amp_conf/htdocs/admin/libraries/BMO/Modules.class.php

%{__mv} LICENSE LICENSE.original.FreePBX
%{__mv} README.md README.original.FreePBX
%{__install} -m0644 %{SOURCE100} ./README
%if 0%{?rhel} >8
%{__install} -m0644 %{SOURCE101} ./APACHE_MOD_PHP
%{__install} -m0644 %{SOURCE103} ./APACHE_PHP_FPM
%else
%{__install} -m0644 %{SOURCE102} ./APACHE_MOD_PHP
%{__install} -m0644 %{SOURCE104} ./APACHE_PHP_FPM
%endif
%{__install} -m0644 %{SOURCE105} ./LIGHTTPD
%{__install} -m0644 %{SOURCE106} ./INSTALL
%{__install} -m0644 %{SOURCE107} ./CDR
%{__install} -m0644 %{SOURCE108} ./NOTES
%{__install} -m0644 %{SOURCE120} .

#perl -pi -e 'print "# Sample freepbx section for cdr in /etc/odbc.ini\n# Put it there if you need it\n" if $. == 1' installlib/files/odbc.ini
#perl -pi -e 's/^driver=.*/driver=MariaDB/' installlib/files/odbc.ini
sed -i -e '1i # Sample freepbx section for cdr in /etc/odbc.ini\n# Put it there if you need it\n' -e 's/^driver=.*/driver=MariaDB/' installlib/files/odbc.ini

%install

# See installcommand.class.php, section // Copy amp_conf/
%{__install} -d %{buildroot}%{_sysconfdir}/asterisk
%{__install} -m0664 amp_conf/astetc/* %{buildroot}%{_sysconfdir}/asterisk/
%{__install} -m0664 amp_conf/astetc/voicemail.conf.template %{buildroot}%{_sysconfdir}/asterisk/voicemail.conf	# See installcommand.class.php, section // Copy /etc/asterisk/voicemail.conf.template to /etc/asterisk/voicemail.conf

%{__install} -d %{buildroot}%{_sysconfdir}/logrotate.d
%{__install} -m0644 etclogrotate.d/freepbx-fwJOB %{buildroot}%{_sysconfdir}/logrotate.d/

%{__install} -d %{buildroot}%{_datadir}/asterisk/bin
%{__install} -m0755 amp_conf/bin/* %{buildroot}%{_datadir}/asterisk/bin

%{__install} -d %{buildroot}%{_datadir}/%{name}
# TODO prendere i .htconfig da qui dentro e metterli in file di sistema
%{__cp} -aR amp_conf/htdocs/{.[a-z]*,*} %{buildroot}%{_datadir}/%{name}/

%{__install} -d %{buildroot}%{_datadir}/asterisk/agi-bin
%{__install} -m0755 amp_conf/agi-bin/* %{buildroot}%{_datadir}/asterisk/agi-bin

%{__install} -d %{buildroot}%{_datadir}/%{name}/admin/modules/%{rawname}
# See installcommand.class.php, $copyFrameworkFiles . Skip LICENSE and README.md since they go into %{doc}
%{__install} -m0664 install.php module.xml phpunit.xml %{buildroot}%{_datadir}/%{name}/admin/modules/%{rawname}

# Copy these too, since in our particular case, I think it will be needed
%{__cp} -aR install installlib upgrades %{buildroot}%{_datadir}/%{name}/admin/modules/%{rawname}

%{__install} -d %{buildroot}%{_sbindir}									# See installcommand.class.php, section //Last minute symlinks
%{__ln_s} %{_datadir}/asterisk/bin/{amportal,fwconsole} %{buildroot}%{_sbindir}/

%{__install} -m0664 installlib/files/asterisk.conf %{buildroot}%{_sysconfdir}/asterisk/			# See installcommand.class.php, section // Copy asterisk.conf
%{__install} -m0664 installlib/files/odbc.ini %{buildroot}%{_sysconfdir}/asterisk/odbc.ini		# See installcommand.class.php, where is define("ODBC_INI", ...

%{__install} -d %{buildroot}/var/log/asterisk/%{name}

%{__install} -d %{buildroot}%{_datadir}/%{name}/admin/modules/_cache					# See installcommand.class.php, section // Create additional dirs
%{__install} -d %{buildroot}%{_datadir}/%{name}/admin/modules/framework					# Questo lo avevo gia creato sopra
%{__install} -d %{buildroot}%{_datadir}/%{name}/admin/assets/less/cache
%{__install} -d %{buildroot}/var/spool/asterisk/voicemail/device
%{__install} -d %{buildroot}/var/spool/asterisk/fax
%{__install} -d %{buildroot}/var/spool/asterisk/cache
#%{__install} -d %{buildroot}/var/spool/asterisk/monitor						# e' in *

%{__install} -d %{buildroot}/var/cache/asterisk

%{__install} -m0640 %{SOURCE2} %{buildroot}%{_sysconfdir}/
%{__install} -m0640 %{SOURCE3} %{buildroot}%{_sysconfdir}/

# install an init script for the service
mkdir -p %{buildroot}%{_unitdir}
install -m 0644 %SOURCE5 %{buildroot}%{_unitdir}/%{name}.service

%post
%systemd_post %{name}.service

if [ $1 -ge 1 ]; then
# Caso upgrade, aggiorno i moduli. 
# Magari sarebbero da gestire le dipendenze...
# /usr/sbin/fwconsole ma list|grep 'Disabled.*Pending upgrade'|cut -f1 -d" "|while read mod; do /usr/share/freepbx/module_admin install $mod; done
# Lascio fare da command line:
/usr/sbin/fwconsole ma list|grep -q 'Disabled.*Pending upgrade' && {
	echo "I seguenti moduli necessitano di aggiornamento:"
	echo
	/usr/sbin/fwconsole ma list|grep 'Disabled.*Pending upgrade'
	echo
	echo "Eseguire /usr/sbin/fwconsole ma install <modulo>"
	echo "per ognuno dei moduli"
	} || :
fi

%preun
%systemd_preun %{name}.service
# Cerchiamo, per quanto possibile, di lasciare in giro poche schifezze
find %{_datadir}/%{name}/admin/assets/less/cache \
     %{_datadir}/%{name}/admin/modules/_cache \
     /var/spool/asterisk/cache \
-mindepth 1 -maxdepth 1 -exec rm -rf '{}' ';'

%postun
%systemd_postun_with_restart %{name}.service

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
# TODO: metti a posto la licenza, in modo da evidenziare come li licenzi tu. E metti una licenza in questo spec in particolare.
%doc LICENSE.original.FreePBX README README.original.FreePBX INSTALL APACHE_MOD_PHP APACHE_PHP_FPM LIGHTTPD CDR NOTES freePBXAsterisk.te
%defattr(0644,%{sown},%{sgrp},0755)

%attr(0664,%{own},%{grp}) %config(noreplace) %{_sysconfdir}/asterisk/*
%attr(0640,%{own},%{grp}) %config(noreplace) %{_sysconfdir}/freepbx.conf
%attr(0640,%{own},%{grp}) %config(noreplace) %{_sysconfdir}/amportal.conf

%attr(0644,%{sown},%{sgrp}) %config(noreplace) %{_sysconfdir}/logrotate.d/*

%attr(0755,%{sown},%{sgrp}) %{_datadir}/asterisk/agi-bin/*
%attr(0755,%{sown},%{sgrp}) %{_datadir}/asterisk/bin/*
#%attr(0644,%{own},%{grp}) %{_datadir}/asterisk/moh/*.wav
#%attr(0755,%{own},%{grp}) %dir %{_datadir}/asterisk/sounds/custom
%{_datadir}/%{name}
#%exclude %{_datadir}/%{name}/admin/modules/_cache
%dir %attr(0775,%{own},%{grp}) %{_datadir}/%{name}/admin/modules/_cache
#%exclude %{_datadir}/%{name}/admin/modules/framework
%dir %attr(0755,%{sown},%{sgrp}) %{_datadir}/%{name}/admin/modules/framework
#%exclude %{_datadir}/%{name}/admin/assets/less/cache
%dir %attr(0755,%{own},%{grp}) %{_datadir}/%{name}/admin/assets/less/cache
%dir %attr(0755,%{own},%{grp}) %{_datadir}/%{name}/admin/assets/js
%attr(0755,%{sown},%{sgrp}) %{_datadir}/%{name}/admin/modules/framework/install
%dir %attr(0775,%{own},%{grp}) /var/spool/asterisk/voicemail/device
%dir %attr(0766,%{own},%{grp}) /var/spool/asterisk/fax
%dir %attr(0775,%{own},%{grp}) /var/spool/asterisk/cache
#%dir %attr(0766,%{own},%{grp}) /var/spool/asterisk/monitor
%dir %attr(0755,%{own},%{grp}) /var/cache/asterisk
%{_sbindir}/*
%{_unitdir}/%{name}.service

# date "+* %a %b %d %Y Luigi Iotti <asterisk@iotti.biz> - 16.0.10.43"
%changelog
* Wed Mar 05 2025 Luigi Iotti <asterisk@iotti.biz> - 17.0.19.24
- Updated version

* Wed Jan 08 2025 Luigi Iotti <asterisk@iotti.biz> - 17.0.19.23
- Updated version

* Mon Dec 02 2024 Luigi Iotti <asterisk@iotti.biz> - 17.0.19.21
- Updated version

* Tue Oct 01 2024 Luigi Iotti <asterisk@iotti.biz> - 16.0.40.11
- Updated version

* Thu Aug 29 2024 Luigi Iotti <asterisk@iotti.biz> - 16.0.40.10
- Updated version

* Thu May 30 2024 Luigi Iotti <asterisk@iotti.biz> - 16.0.40.8
- Updated version

* Fri Oct 06 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.40.7
- Updated version

* Fri Jun 23 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.40.4
- Updated version

* Tue May 23 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.40.3
- Updated version

* Fri May 12 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.40.2
- Updated version

* Tue Mar 28 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.40
- Updated version

* Sat Mar 18 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.39
- Updated version

* Thu Feb 09 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.33
- Updated version

* Fri Jan 06 2023 Luigi Iotti <asterisk@iotti.biz> - 16.0.30
- Updated version

* Mon Dec 26 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.28
- Updated version

* Thu Nov 03 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.26
- Updated version

* Thu Oct 20 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.23
- Updated version

* Wed Sep 07 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.21.18
- Updated version

* Sun Aug 07 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.21.9
- Updated version

* Sat Jul 30 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.21.8
- Updated version

* Tue Jun 14 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.21.3
- Updated version

* Mon Mar 07 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.19
- Updated version

* Wed Feb 23 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.17
- Updated version

* Wed Feb 09 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.15
- Updated version

* Fri Feb 04 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.14
- Updated version

* Thu Feb 03 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.10.50-5
- Manage /var/spool/asterisk/cache

* Fri Jan 28 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.10.50
- More install.php cleanups

* Thu Jan 27 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.10.50
- Remove fwconsole system: here system updates are done by the admin
- Remove more module download functionality
- Don't delete /usr/share/freepbx/admin/libraries/Composer/vendor/doctrine/cache/* in preun scripts
- Updated version

* Tue Jan 25 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.10.43
- nochown patch reorganization (reconfusion:)
- Delete Chown class and remove more chowns

* Sat Jan 22 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.10.43-2
- Delete the cron thing: updates are sysadm' thing
- Eliminate more wild chowns
- Skip installing base modules too. The sysadmin must work:)
- Update paths in installlib/installcommand.class.php since
  we now install from the definitive dir, and don't copy anything around

* Fri Jan 21 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.10.43-1
- Remove dependency from php-pear-DB
- Put back in place amportal.conf by not applying patch 3

* Sat Jan 15 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.10.43-1
- Patch to force skipchown in fwconsole commands and to remove the command line option
- Initial build
